import DateUtil from "./DateUtil.js";
import Environment from "./Environment.js";

export default class Log {

  static LOG_TIME = true;

  static log(message, data = null) {
    this._completeLog(`[INFO]: ${message}`, data);
  }

  static measure(message, data = null) {
    if (!Environment.MEASURE()) return;
    this._completeLog(`[MEASURE]: ${message}`, data);
  }

  static debug(message, data = null) {
    if (!Environment.DEBUG()) return;
    this._completeLog(`[DEBUG]: ${message}`, data);
  }

  static warn(message, data = null) {
    this._completeLog(`[WARN]: ${message}`, data);
  }

  static error(message, error = null) {
    this._completeLog(`[ERROR]: ${message}`, error);
  }

  static _completeLog(message, data) {
    let log;
    if (this.LOG_TIME) {
      log += `${this._UTCDate()} - `;
    }
    log += message;
    console.log(log);

    if (data) {
      console.log(data);
    }
  }

  static _UTCDate() {
    return DateUtil.now().toUTCString();
  }

}
